var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "te-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
        
        // public method for url encoding
        encode : function (string) {
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
     
            for (var n = 0; n < string.length; n++) {
     
                var c = string.charCodeAt(n);
     
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
     
            }
     
            return utftext;
        },
     
        // public method for url decoding
        decode : function (utftext) {
            var string = "";
            var i = 0;
            var c = c1 = c2 = 0;
     
            while ( i < utftext.length ) {
     
                c = utftext.charCodeAt(i);
     
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i+1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i+1);
                    c3 = utftext.charCodeAt(i+2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
     
            }
     
            return string;
        }
     
    }

function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('entries/' + path, value);
        Property.setFlag('entries/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}


function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function putActionParameter(idValue,oParameterObject) {
    
    for ( var iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
        var oSubobject = oParameterObject.actions[iIndex];
        storeSubParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type);
        switch (oSubobject.type) {
            case 'zone-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-scene':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
                storeSubParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene);
                storeSubParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force);
            break;
            case 'device-value':
                storeSubParameter(idValue + '/actions/' + iIndex + '/value', oSubobject.value);
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'device-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid);
            break;
            case 'zone-blink':
                storeSubParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone);
                storeSubParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group);
            break;
            case 'custom-event':
                storeSubParameter(idValue + '/actions/' + iIndex + '/event', oSubobject.event);
            break;
            case 'url':
                storeSubParameter(idValue + '/actions/' + iIndex + '/url', oSubobject.url);
            break;
        }
        if (oSubobject.delay!=null) {
            storeSubParameter(idValue + '/actions/' + iIndex + '/delay', oSubobject.delay);
        }
    }    
}

function putRecurrenceParameter(idValue,oParameterObject) {
    if (oParameterObject.recurrence!=null) {
        storeSubParameter(idValue + '/time/recurrenceBase', oParameterObject.recurrence.recurrenceBase);
        if (oParameterObject.recurrence.recurrenceBase=='absolute') {
            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++){
                storeSubParameter(idValue + '/time/date/' + iIndex , oParameterObject.recurrence.timeArray[iIndex]);
            }
        } else {
            for (var iIndex=0;iIndex<oParameterObject.recurrence.timeArray.length;iIndex++){
                storeSubParameter(idValue + '/time/recurrence/' + iIndex , oParameterObject.recurrence.timeArray[iIndex]);
            }
        }
    }
}

function putTimerParameter(idValue,oParameterObject) {
    if (oParameterObject.time!=null) {
        storeSubParameter(idValue + '/time/timeBase', oParameterObject.time.timeBase);
        storeSubParameter(idValue + '/time/offset', oParameterObject.time.offset);
        if (oParameterObject.time.limitAfter!=null)
            storeSubParameter(idValue + '/time/limitAfter', oParameterObject.time.limitAfter);
        if (oParameterObject.time.limitBefore!=null)
            storeSubParameter(idValue + '/time/limitBefore', oParameterObject.time.limitBefore);
        if (oParameterObject.time.random!=null)
            storeSubParameter(idValue + '/time/random', parseInt(oParameterObject.time.random,10));
        if (oParameterObject.time.propertyReference!=null)
            storeSubParameter(idValue + '/time/propertyReference', oParameterObject.time.propertyReference);
    }
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null)
            idValue = oParameterObject.id;
        else
            idValue = getNewIdValue();

        var baseNode = Property.getNode('entries');
        if (baseNode != null)
            baseNode.removeChild(idValue);

        storeSubParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue+ '/conditions/enabled', true);

        putActionParameter(idValue,oParameterObject);
        putTimerParameter(idValue,oParameterObject);    
        putRecurrenceParameter(idValue,oParameterObject);
        Property.store();
        setOneEvent(Property.getNode('entries/' + idValue));
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    }
}

if (raisedEvent.name == 'system-addon-timed-events.config') {
    lInfo.logln("TE-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("TE-Config param value " + raisedEvent.parameter.value);       
        var id=storeValue(raisedEvent.parameter.value);
        Property.store();   
        var evt = new Event("system-addon-timed-events.saved", {id:id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("TE-Config enable value " +unescape( raisedEvent.parameter.id));

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)=='number')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {        
            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
        }

        Property.store();
        var evt = new Event("system-addon-timed-events.saved", {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("TE-Config disable value " + unescape(raisedEvent.parameter.id));

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)=='number')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {        
            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);
        }
        
        Property.store();
        var evt = new Event("system-addon-timed-events.saved", {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("TE-Config delete value " + unescape(raisedEvent.parameter.id));

        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)=='number')
            oIDObject=[oIDObject];
        for (var sKey in oIDObject) {
            
            resetOneEvent('dynamic/scheduledFixedEvents/' +oIDObject[sKey]);
            resetOneEvent('dynamic/scheduledMultipleEvents/' + oIDObject[sKey]);
            resetOneEvent('dynamic/scheduledDynamicEvents/' + oIDObject[sKey]);

            var baseNode = Property.getNode('entries');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);
        }
        Property.store();
        var evt = new Event("system-addon-timed-events.saved",  {id:raisedEvent.parameter.id});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'updateTimer') {
        lInfo.logln("TE-Config updateTrigger ");     
        queueAllTimedEvents();
    }
    if (raisedEvent.parameter.actions =='suntime-reschedule') {
        lInfo.logln("TE-Config suntime-reschedule "); 
        queueAllTimedEvents();
    }
}

if (raisedEvent.name == 'system-addon-timed-events.random_action_execute') {
    var path=raisedEvent.parameter.path;
    if (path!=null) {
        lInfo.logln("system-addon-timed-events.random_action_execute for " + path); 
        Property.load();
        var baseNode=Property.getNode(path);
        if (baseNode!=null){
            var delayNode=baseNode.getChild('time/random');
            if (delayNode!=null) {
                var deltaTime=Math.floor(delayNode.getValue() *  Math.random());
                lInfo.logln("system-addon-timed-events.random_action_execute : Deltatime should be " + deltaTime);
                var timerEvent = new TimedEvent('action_execute', '+' + deltaTime, {
                    path: path                         
                });     
                lInfo.logln("system-addon-timed-events.random_action_execute : queueing as " + timerEvent.raise());
            }
        } 
    } else
        lInfo.logln("system-addon-timed-events.random_action_execute : no path parameter");
}